using System.Diagnostics;
using System;
using System.Windows.Forms;
using System.Collections;
using System.Drawing;
using Microsoft.VisualBasic;
using System.Data;
using System.Collections.Generic;
using System.Data.OleDb;
using System.IO;

namespace Library
{
	public partial class FrmAmanat
	{
		public FrmAmanat()
		{
			InitializeComponent();
		}
		
		public void btnExit_Click(System.Object sender, System.EventArgs e)
		{
			this.Close();
		}
		
		public void FrmAmanat_Load(System.Object sender, System.EventArgs e)
		{
			OleDbConnection1.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=D:\\Projects\\LibraryProject\\library.mdb";
			OleDbDataAdapter1.Fill(LibraryDataSet1.tbl_amanat);
		}
		
		public void txtMemberCode_TextChanged(System.Object sender, System.EventArgs e)
		{
			OleDbDataAdapter1.SelectCommand.CommandText = "SELECT * FROM tbl_amanat WHERE am_member_code LIKE\'" + txtMemberCode.Text + "%\' and am_resid=false";
			LibraryDataSet1.tbl_amanat.Clear();
			OleDbDataAdapter1.Fill(LibraryDataSet1.tbl_amanat);
			if (LibraryDataSet1.tbl_amanat.Count == 0)
			{
				txtDateStart.Text = "";
				txtDateEnd.Text = "";
				Txtbookcode.Text = "";
			}
		}
		
		public void LinkLabel1_LinkClicked(System.Object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			FrmListMember frm = new FrmListMember();
			frm.ShowDialog();
			txtMemberCode.Text = frm.code;
		}
		
		public void LinkLabel2_LinkClicked(System.Object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			FrmBookList frm = new FrmBookList();
			frm.ShowDialog();
			Txtbookcode.Text = frm.bookcode;
			
		}
		
		public void btnInsert_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				bool blnerror = System.Convert.ToBoolean(false);
				ErrorProvider1.Clear();
				if (Information.IsNumeric(txtMemberCode.Text))
				{
					OleDbDataAdapter2.SelectCommand.Parameters[0].Value = Conversion.Val(txtMemberCode.Text);
					LibraryDataSet1.tbl_member.Clear();
					OleDbDataAdapter2.Fill(LibraryDataSet1.tbl_member);
					if (LibraryDataSet1.tbl_member.Rows.Count == 0)
					{
						blnerror = true;
						ErrorProvider1.SetError(txtMemberCode, "کد عضویت در بانك ثبت نشده است");
					}
				}
				else
				{
					blnerror = true;
					ErrorProvider1.SetError(txtMemberCode, "کد عضویت را درست وارد کنید");
				}
				
				if (blnerror == false)
				{
					if (Txtbookcode.Text != "")
					{
						OleDbDataAdapter3.SelectCommand.Parameters[0].Value = Txtbookcode.Text;
						LibraryDataSet1.tbl_book.Clear();
						OleDbDataAdapter3.Fill(LibraryDataSet1.tbl_book);
						if (LibraryDataSet1.tbl_book.Rows.Count == 0)
						{
							blnerror = true;
							ErrorProvider1.SetError(Txtbookcode, "کد کتاب در بانك ثبت نشده است");
						}
					}
					else
					{
						blnerror = true;
						ErrorProvider1.SetError(Txtbookcode, "کد کتاب را درست وارد کنید");
					}
				}
				if (blnerror == false)
				{
					if (! Information.IsDate(txtDateStart.Text))
					{
						blnerror = true;
						ErrorProvider1.SetError(txtDateStart, "تاریخ گرفتن کتاب را درست وارد نمایید");
					}
					else if (! Information.IsDate(txtDateEnd.Text))
					{
						blnerror = true;
						ErrorProvider1.SetError(txtDateEnd, "تاریخ برگشت کتاب را درست وارد نمایید");
					}
					else
					{
						int t =  (int) (DateAndTime.DateDiff(DateInterval.Day, DateTime.Parse(txtDateStart.Text), DateTime.Parse(txtDateEnd.Text), Microsoft.VisualBasic.FirstDayOfWeek.Sunday, Microsoft.VisualBasic.FirstWeekOfYear.Jan1));
						if (t < 0)
						{
							blnerror = true;
							ErrorProvider1.SetError(txtDateEnd, "تاریخ برگشت نباید قبل از تاریخ گرفتن کتاب باشد");
						}
					}
				}
				
				if (blnerror == false)
				{
					OleDbDataAdapter1.InsertCommand.Parameters[0].Value = txtMemberCode.Text;
					OleDbDataAdapter1.InsertCommand.Parameters[1].Value = Txtbookcode.Text;
					OleDbDataAdapter1.InsertCommand.Parameters[2].Value = DateTime.Parse(txtDateStart.Text);
					OleDbDataAdapter1.InsertCommand.Parameters[3].Value = DateTime.Parse(txtDateEnd.Text);
					OleDbDataAdapter1.InsertCommand.Parameters[4].Value = false;
					if (OleDbConnection1.State == ConnectionState.Closed)
					{
						OleDbConnection1.Open();
					}
					OleDbDataAdapter1.InsertCommand.ExecuteNonQuery();
					
					LibraryDataSet1.tbl_amanat.Clear();
					OleDbDataAdapter1.Fill(LibraryDataSet1.tbl_amanat);
				}
				Interaction.MsgBox(" اطلاعات با موفقيت در بانك درج گرديد", 0, "عمليات درج");
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error : " + ex.Message);
			}
			
		}
		
		public void DataGridView1_Click(System.Object sender, System.EventArgs e)
		{
			int index = BindingContext[LibraryDataSet1, "tbl_amanat"].Position;
			Txtbookcode.Text = (string) (LibraryDataSet1.tbl_amanat[index].am_book_isbn);
			txtDateStart.Text = System.Convert.ToString((LibraryDataSet1.tbl_amanat[index].am_start));
			txtDateEnd.Text = System.Convert.ToString((LibraryDataSet1.tbl_amanat[index].am_end));
			txtMemberCode.Text = System.Convert.ToString((LibraryDataSet1.tbl_amanat[index].am_member_code));
			
		}
		
		public void btnUpdate_Click(System.Object sender, System.EventArgs e)
		{
			int index = BindingContext[LibraryDataSet1, "tbl_amanat"].Position;
			if (index != -1)
			{
				LibraryDataSet1.tbl_amanat[index].am_member_code = int.Parse(txtMemberCode.Text);
				LibraryDataSet1.tbl_amanat[index].am_book_isbn = Txtbookcode.Text;
				LibraryDataSet1.tbl_amanat[index].am_start = DateTime.Parse(txtDateStart.Text);
				LibraryDataSet1.tbl_amanat[index].am_end = DateTime.Parse(txtDateEnd.Text);
				OleDbDataAdapter1.Update(LibraryDataSet1, "tbl_amanat");
				LibraryDataSet1.Clear();
				OleDbDataAdapter1.Fill(LibraryDataSet1.tbl_amanat);
				Interaction.MsgBox("ويرايش با موفقيت صورت پذيرفت ", 0, " عمليات ويرايش");
			}
			
		}
		
		public void DataGridView1_CellEndEdit(System.Object sender, System.Windows.Forms.DataGridViewCellEventArgs e)
		{
			OleDbDataAdapter1.Update(LibraryDataSet1.tbl_amanat);
			LibraryDataSet1.Clear();
			OleDbDataAdapter1.Fill(LibraryDataSet1.tbl_amanat);
			int index = BindingContext[LibraryDataSet1, "tbl_amanat"].Position;
			
			Txtbookcode.Text = (string) (LibraryDataSet1.tbl_amanat[index].am_book_isbn);
			txtDateStart.Text = System.Convert.ToString((LibraryDataSet1.tbl_amanat[index].am_start));
			txtDateEnd.Text = System.Convert.ToString((LibraryDataSet1.tbl_amanat[index].am_end));
			txtMemberCode.Text = System.Convert.ToString((LibraryDataSet1.tbl_amanat[index].am_member_code));
			
		}
		
		public void btnDelete_Click(System.Object sender, System.EventArgs e)
		{
			int indexrow;
			indexrow = BindingContext[this.LibraryDataSet1, "tbl_amanat"].Position;
			if (indexrow != -1)
			{
				LibraryDataSet1.tbl_amanat.Rows[indexrow].Delete();
				OleDbDataAdapter1.Update(LibraryDataSet1.tbl_amanat);
				LibraryDataSet1.tbl_amanat.Clear();
				OleDbDataAdapter1.Fill(LibraryDataSet1.tbl_amanat);
				txtDateStart.Text = "";
				txtDateEnd.Text = "";
				Txtbookcode.Text = "";
				txtMemberCode.Text = "";
				Interaction.MsgBox(" حذف با موفقيت صورت پذيرفت", 0, " عمليات حذف");
			}
		}
	}
}
