using System.Diagnostics;
using System;
using System.Windows.Forms;
using System.Collections;
using System.Drawing;
using Microsoft.VisualBasic;
using System.Data;
using System.Collections.Generic;

namespace Library
{
	public partial class FrmBook
	{
		public FrmBook()
		{
			InitializeComponent();
		}
		
		
		public void FrmBook_Load(System.Object sender, System.EventArgs e)
		{
			OleDbConnection1.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=D:\\Projects\\LibraryProject\\library.mdb";
			LibraryDataSet1.tbl_book.Clear();
			OleDbDataAdapter1.Fill(LibraryDataSet1.tbl_book);
		}
		
		public void btnnewbook_Click(System.Object sender, System.EventArgs e)
		{
			ErrorProvider1.Clear();
			OleDbDataAdapter2.SelectCommand.Parameters[0].Value = txtISBN.Text;
			LibraryDataSet1.tbl_book1.Clear();
			OleDbDataAdapter2.Fill(LibraryDataSet1.tbl_book1);
			if ((LibraryDataSet1.tbl_book1.Rows.Count > 0) || (txtISBN.Text == ""))
			{
				ErrorProvider1.SetError(txtISBN, " كد شناسايي كتاب نبايد خالي يا تكراري باشد");
			}
			else if (txtTitle.Text == "")
			{
				ErrorProvider1.SetError(txtTitle, "  عنوان كتاب را وارد نمائيد");
			}
			else if (txtMoalef.Text == "")
			{
				ErrorProvider1.SetError(txtMoalef, "نام مولف را وارد كنيد");
			}
			else if (txtNumPrint.Text == "")
			{
				ErrorProvider1.SetError(txtNumPrint, "شماره و سال چاپ را وارد نمائيد");
			}
			else if (cmbGroup.SelectedIndex == -1)
			{
				ErrorProvider1.SetError(cmbGroup, "گروه كتاب را انتخاب كنيد");
			}
			else if (! Information.IsNumeric(txtTotalPage.Text))
			{
				ErrorProvider1.SetError(txtTotalPage, " تعداد صفحات كتاب را وارد نمائيد");
			}
			else if (! Information.IsNumeric(txtTotal.Text))
			{
				ErrorProvider1.SetError(txtTotal, "موجودي را درست وارد نمائيد");
			}
			else
			{
				try
				{
					OleDbDataAdapter1.InsertCommand.Parameters[0].Value = txtISBN.Text;
					OleDbDataAdapter1.InsertCommand.Parameters[1].Value = txtTitle.Text;
					OleDbDataAdapter1.InsertCommand.Parameters[2].Value = cmbGroup.Text;
					OleDbDataAdapter1.InsertCommand.Parameters[3].Value = txtNumPrint.Text;
					OleDbDataAdapter1.InsertCommand.Parameters[4].Value = txtMoalef.Text;
					OleDbDataAdapter1.InsertCommand.Parameters[5].Value = txtTotal.Text;
					OleDbDataAdapter1.InsertCommand.Parameters[6].Value = txtTotalPage.Text;
					OleDbConnection1.Open();
					OleDbDataAdapter1.InsertCommand.ExecuteNonQuery();
					LibraryDataSet1.tbl_book.Clear();
					OleDbDataAdapter1.Fill(LibraryDataSet1.tbl_book);
					txtISBN.Clear();
					txtTitle.Clear();
					txtNumPrint.Clear();
					txtMoalef.Clear();
					txtTotalPage.Clear();
					txtTotal.Clear();
					cmbGroup.Text = "";
					Interaction.MsgBox(" اطلاعات كتاب جديد با موفقيت به بانك اضافه گرديد", 0, "عمليات درج");
				}
				catch (Exception ex)
				{
					MessageBox.Show("Error: " + ex.Message);
				}
				finally
				{
					if (OleDbConnection1.State == ConnectionState.Open)
					{
						OleDbConnection1.Close();
					}
				}
				
			}
		}
		
		public void DataGridView1_Click(System.Object sender, System.EventArgs e)
		{
			int IndexRow;
			try
			{
				IndexRow = BindingContext[this.LibraryDataSet1, "tbl_book"].Position;
				txt_ISBN_Update.Text = (string) (LibraryDataSet1.tbl_book[IndexRow].b_isbn);
				txt_Title_Update.Text = (string) (LibraryDataSet1.tbl_book[IndexRow].b_title);
				txt_Moalef_Update.Text = (string) (LibraryDataSet1.tbl_book[IndexRow].b_moalef);
				txt_numprint_Update.Text = (string) (LibraryDataSet1.tbl_book[IndexRow].b_print);
				Cmb_Group_Update.Text = (string) (LibraryDataSet1.tbl_book[IndexRow].b_group);
				txt_Totalpage_update.Text = System.Convert.ToString((LibraryDataSet1.tbl_book[IndexRow].b_page));
				txt_Total_Update.Text = System.Convert.ToString((LibraryDataSet1.tbl_book[IndexRow].b_total));
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error :" + ex.Message);
			}
		}
		
		public void btnDelete_Click(System.Object sender, System.EventArgs e)
		{
			int IndexRow;
			IndexRow = BindingContext[this.LibraryDataSet1, "tbl_book"].Position;
			if (IndexRow != -1)
			{
				try
				{
					LibraryDataSet1.tbl_book[IndexRow].Delete();
					OleDbDataAdapter1.Update(LibraryDataSet1.tbl_book);
					txt_ISBN_Update.Clear();
					txt_Title_Update.Clear();
					txt_numprint_Update.Clear();
					txt_Moalef_Update.Clear();
					txt_Totalpage_update.Clear();
					txt_Total_Update.Clear();
					Cmb_Group_Update.Text = "";
					LibraryDataSet1.tbl_book.Clear();
					OleDbDataAdapter1.Fill(LibraryDataSet1.tbl_book);
					Interaction.MsgBox("ركورد مورد نظر از بانك حذف گرديد", 0, "عمليات حذف");
				}
				catch (Exception ex)
				{
					MessageBox.Show("Error :" + ex.Message);
					
				}
			}
			
		}
		
		public void btnUpdate_Click(System.Object sender, System.EventArgs e)
		{
			int IndexRow;
			IndexRow = BindingContext[this.LibraryDataSet1, "tbl_book"].Position;
			if (IndexRow >= 0)
			{
				ErrorProvider1.Clear();
				if (txt_ISBN_Update.Text == "")
				{
					ErrorProvider1.SetError(txt_ISBN_Update, " عنوان كتاب را وارد نمائيد");
				}
				else if (txt_Moalef_Update.Text == "")
				{
					ErrorProvider1.SetError(txt_Moalef_Update, "نام مؤلف را وارد كنيد");
				}
				else if (txt_numprint_Update.Text == "")
				{
					ErrorProvider1.SetError(txt_numprint_Update, " شماره چاپ را وارد نمائيد");
				}
				else if (Cmb_Group_Update.SelectedIndex == -1)
				{
					ErrorProvider1.SetError(Cmb_Group_Update, "گروه كتاب را انتخاب نمائيد");
				}
				else if (! Information.IsNumeric(txt_Totalpage_update.Text))
				{
					ErrorProvider1.SetError(txt_Totalpage_update, "تعداد صفحات كتاب را درست وارد نمائيد");
				}
				else if (! Information.IsNumeric(txt_Total_Update.Text))
				{
					ErrorProvider1.SetError(txt_Total_Update, " تعداد موجودي را وارد نمائيد");
				}
				else
				{
					try
					{
						LibraryDataSet1.tbl_book[IndexRow].b_title = txt_Title_Update.Text;
						LibraryDataSet1.tbl_book[IndexRow].b_moalef = txt_Moalef_Update.Text;
						LibraryDataSet1.tbl_book[IndexRow].b_print = txt_numprint_Update.Text;
						LibraryDataSet1.tbl_book[IndexRow].b_group =  (string) (Cmb_Group_Update.SelectedItem);
						LibraryDataSet1.tbl_book[IndexRow].b_page = int.Parse(txt_Totalpage_update.Text);
						LibraryDataSet1.tbl_book[IndexRow].b_total = int.Parse(txt_Total_Update.Text);
						OleDbDataAdapter1.Update(LibraryDataSet1, "tbl_book");
						txt_ISBN_Update.Clear();
						txt_Title_Update.Clear();
						txt_Moalef_Update.Clear();
						txt_numprint_Update.Clear();
						Cmb_Group_Update.Text = "";
						txt_Totalpage_update.Clear();
						txt_Total_Update.Clear();
						LibraryDataSet1.tbl_book.Clear();
						OleDbDataAdapter1.Fill(LibraryDataSet1.tbl_book);
						Interaction.MsgBox("ويرايش با موفقيت صورت پذيرفت", 0, "عمليات ويرايش");
					}
					catch (Exception ex)
					{
						MessageBox.Show("Error :" + ex.Message);
					}
				}
			}
		}
	}
}
